/******************************************************************************/
/******************************************************************************/
/* Trigger: DTULTATU_ALANDAR                                                  */
/* Tabela : ALANDAR                                                    	      */
/*                                                               	            */
/* Criao:                                                                   */
/* 02/02/2005 - Jonathan Abdon Silva                            	            */
/*                      					                                       */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_ALANDAR'  and
            type = 'TR'                  and
            u.uid = o.uid                and
            u.name = USER)
  DROP TRIGGER DTULTATU_ALANDAR
  GO


CREATE TRIGGER DTULTATU_ALANDAR
ON ALANDAR
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
         INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
               (SELECT 'ALANDAR', CDFILIAL, 'CDANDAR='+ CDANDAR +';CDFILIAL='+ CDFILIAL +';CDALA='+ CDALA +';', GETDATE()                 FROM DELETED)    END
   ELSE BEGIN
      UPDATE ALANDAR
      SET DTULTATUALAN = GETDATE()
      FROM INSERTED
      WHERE
         (ALANDAR.CDANDAR  = INSERTED.CDANDAR ) AND
         (ALANDAR.CDALA    = INSERTED.CDALA   ) AND
         (ALANDAR.CDFILIAL = INSERTED.CDFILIAL)
   END;
END;
GO



