/*

Descrio: Criada para encaixar a data de produo no horario do turno de trabalho.
Criao: Welbert G. Moitinha
Data: 28/06/2010

*/


IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'ENCAIXA_PRODUCAO_TURNO' AND
                 TYPE = 'FN' 		       AND
	              U.UID = O.UID            AND
	              U.NAME = USER)
DROP FUNCTION ENCAIXA_PRODUCAO_TURNO
GO

CREATE FUNCTION ENCAIXA_PRODUCAO_TURNO
   (@P_CDFILIAL     VARCHAR(4),
    @P_DTAPRODUZIR  DATETIME )RETURNS DATETIME
AS
BEGIN

   DECLARE @V_VEXISHORATUR   VARCHAR(4);
   DECLARE @V_TURNOINIANT    VARCHAR(4);
   DECLARE @V_TURNOFIMANT    VARCHAR(4);
   DECLARE @V_TURNOAUXI      VARCHAR(4);
   DECLARE @V_DTTURNOAUXI    DOUBLE PRECISION;
   DECLARE @V_DTAPRODUZIR DATETIME;

   SET @V_DTAPRODUZIR = @P_DTAPRODUZIR;

/* VERIFICA SE A DATA A PRODUZIR PERTENCE A ALGUM TURNO DE TRABALHO */

   SELECT
      @V_VEXISHORATUR = MAX(T.HRINITURNO)
     FROM
      (SELECT
          NRTURNO,
          HRINITURNO,
          HRFIMTURNO,
          CASE CONVERT(INT,HRFIMTURNO) - CONVERT(INT,HRINITURNO)
              WHEN ABS(CONVERT(INT,HRFIMTURNO) - CONVERT(INT,HRINITURNO)) THEN CONVERT(INT,HRFIMTURNO)
              ELSE CONVERT(INT, HRFIMTURNO) + 2400 END AS HRFINPRODU
       FROM TURNO_PRODUCAO
       WHERE
          (CDFILIAL = @P_CDFILIAL)
      ) T
   WHERE
      ((CASE CONVERT(INT,T.HRFIMTURNO) - CONVERT(INT,T.HRINITURNO) WHEN ABS(CONVERT(INT,T.HRFIMTURNO) - CONVERT(INT,T.HRINITURNO)) THEN
            CONVERT(int,(SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),1,2) + SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),4,2))) ELSE
            CASE CONVERT(INT,T.HRINITURNO) - CONVERT(int,(SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),1,2) + SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),4,2))) WHEN
                 ABS(CONVERT(INT,T.HRINITURNO) - CONVERT(int,(SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),1,2) + SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),4,2)))) THEN
                 CONVERT(int,(SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),1,2) + SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),4,2))) + 2400 ELSE
                 CONVERT(INT,T.HRINITURNO) END END BETWEEN T.HRINITURNO AND T.HRFIMTURNO));


   /* se no possuir, verifica o turno anterior */
   IF @V_VEXISHORATUR IS NULL BEGIN
      SELECT
         @V_TURNOINIANT = MAX(T.HRINITURNO)
      FROM
         (SELECT
             MAX(HRINITURNO) AS HRINITURNO
          FROM
             TURNO_PRODUCAO
          WHERE
             (CDFILIAL   = @P_CDFILIAL)   AND
             (HRINITURNO > CONVERT( INT, (SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),1,2) + SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),4,2))))
         ) A,
         TURNO_PRODUCAO T
      WHERE
         (T.CDFILIAL   = @P_CDFILIAL)   AND
         (T.HRINITURNO = A.HRINITURNO);

      SET @V_DTTURNOAUXI = CONVERT(NUMERIC,CONVERT(DATETIME, CONVERT(VARCHAR,CONVERT(VARCHAR, @V_DTAPRODUZIR, 103) + ' ' + (SUBSTRING(@V_TURNOINIANT,1,2) + ':'+ SUBSTRING(@V_TURNOINIANT,3,2))),103) - @V_DTAPRODUZIR,108);

      SELECT @V_TURNOFIMANT = MAX(T.HRFIMTURNO)
      FROM
         (SELECT
             MAX(HRFIMTURNO) AS HRFIMTURNO
          FROM
             TURNO_PRODUCAO
          WHERE
             (CDFILIAL   = @P_CDFILIAL) AND
             (HRFIMTURNO < CONVERT( INT, (SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),1,2) + SUBSTRING(CONVERT(CHAR, @V_DTAPRODUZIR, 108),4,2))))
         ) A,
         TURNO_PRODUCAO T
      WHERE
         (T.CDFILIAL   = @P_CDFILIAL)   AND
         (T.HRFIMTURNO = A.HRFIMTURNO);

      SET @V_TURNOAUXI = SUBSTRING(CONVERT(VARCHAR,CONVERT(DATETIME,CONVERT(VARCHAR, @V_DTAPRODUZIR, 103) + ' ' + SUBSTRING(@V_TURNOFIMANT,1,2) + ':'+ SUBSTRING(@V_TURNOFIMANT,3,2), 103) - @V_DTTURNOAUXI,103),1,2) +
                         SUBSTRING(CONVERT(VARCHAR,CONVERT(DATETIME,CONVERT(VARCHAR, @V_DTAPRODUZIR, 103) + ' ' + SUBSTRING(@V_TURNOFIMANT,1,2) + ':'+ SUBSTRING(@V_TURNOFIMANT,3,2), 103) - @V_DTTURNOAUXI,103),4,2);

      IF NOT @V_TURNOINIANT IS NULL BEGIN
         SET @V_DTAPRODUZIR = CONVERT(DATETIME, CONVERT(VARCHAR,CONVERT(VARCHAR, @V_DTAPRODUZIR, 103) + ' '+ (SUBSTRING(@V_TURNOAUXI,1,2) + ':'+ SUBSTRING(@V_TURNOAUXI,3,2))),103);
      END;
   END;

   RETURN(@V_DTAPRODUZIR);
END;
GO


-- VERSAO --
EXEC ATUVEROBJ 'ENCAIXA_PRODUCAO_TURNO','4.00.000';
GO

