/*
 @C:\Web_635\Sql\End_Conv\SQLServer\3968_PEDFUNO_PESOPRODUTO_PEDIDO.SQL

 Descrio:
 Funo para retornar o peso do pedido

 Parmetros

 @P_CDFILIAL    - Cdigo da filial
 @P_NRPEDIDO    - Nmero do pedido

 RAISERROR('', 16,1);
*/

IF EXISTS (SELECT *
             FROM SYSOBJECTS O, SYSUSERS U
            WHERE O.NAME = 'PESOPRODUTO_PEDIDO'
              AND TYPE = 'FN'
              AND U.UID = O.UID
              AND U.NAME = USER)

DROP FUNCTION PESOPRODUTO_PEDIDO
GO

CREATE FUNCTION PESOPRODUTO_PEDIDO(
   @P_CDFILIAL VARCHAR(4),
   @P_NRPEDIDO VARCHAR(10)) RETURNS NUMERIC(10,5)
AS
BEGIN
   DECLARE @V_VRPBRUVOLPED DOUBLE PRECISION;

   SET @V_VRPBRUVOLPED = 0;

   SELECT @V_VRPBRUVOLPED = SUM( I.QTITEMPED * ISNULL(A.VRPESOBRUTPR, 0))
     FROM PRODUTO A,  ITEMPEDIDO I
    WHERE (I.CDPRODUTO = A.CDPRODUTO)
      AND (I.CDFILIAL  = @P_CDFILIAL)
      AND (I.NRPEDIDO  = @P_NRPEDIDO);

   RETURN(@V_VRPBRUVOLPED);
END
GO

-- VERSAO --
EXEC ATUVEROBJ 'PESOPRODUTO_PEDIDO','6.35.020';
GO
