/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8970_SUPSTPS.sql

Descrio:
Ajusta a conta a pagar prevista quando uma ou mais itens de uma AF
so baixados manualmente ou a AF  cancelada/encerrada.

Criao:
10/11/2006 Marcelo Alexsandro Souza Silva

*/

IF EXISTS (SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'AJUSTE_CONTPREVISTA'  and
            type = 'P'                       and
            u.uid = o.uid                    and
            u.name = USER)

   DROP PROCEDURE AJUSTE_CONTPREVISTA;
GO

CREATE PROCEDURE AJUSTE_CONTPREVISTA
   @P_CDFILDEST  VARCHAR(4),
   @P_CDFILLANC  VARCHAR(4),
   @P_NRAUTOFORN VARCHAR(10)

AS

DECLARE  @V_TOTITM_VRDESC       NUMERIC; /* DESCONTOS DO PRODUTO */
DECLARE  @V_TOTITM_VRPROD       NUMERIC; /* VALOR BRUTO DOS PRODUTOS */
DECLARE  @V_TOTITM_VRPROD_REST  NUMERIC; /* VALOR BRUTO RESTANTE DOS PRODUTOS */
DECLARE  @V_TOTITM_TOT          NUMERIC; /* VALOR BRUTO DOS PRODUTOS MENOS DESCONTOS */
DECLARE  @V_TOTIMP_TOT_REST     NUMERIC; /* TOTAL DE IMPOSTOS PROPROCIONAL AO RESTANTE A SER ENTREGUE */
DECLARE  @V_TOTIMP_TOT          NUMERIC; /* TOTAL DE IMPOSTOS */
DECLARE  @V_ENCACRES_TOTACRES   NUMERIC; /* ENCARGOS A ACRESCER */
DECLARE  @V_ENCDESC_TOTDESC     NUMERIC; /* ENCARGOS A DESCONTAR */
DECLARE  @V_IMPRETER_TOTIMPRET  NUMERIC; /* IMPOSTOS A RETER NA FONTE */
DECLARE  @V_VRTOTCTPAGAR        NUMERIC; /* TOTAL DAS CONTAS A PAGAR */
DECLARE  @V_VRTOTAL_REST        NUMERIC; /* NOVO VALOR DAS CONTAS A PAGAR (RESTANTE A SER ENTREGUE) */

DECLARE  @V_VRATUAPAGAUX        NUMERIC;
DECLARE  @V_IDSTATUSAUX         VARCHAR(1);

DECLARE  @V_IDGERCONTPGT        VARCHAR(1);
DECLARE  @V_IDCONSORCFIN        VARCHAR(1);
DECLARE  @V_IDTPORCAFINA        VARCHAR(1);
DECLARE  @V_CDFILIAL            VARCHAR(4);

/*DECLARE VARIAVEL DO CURSOR  C_FORNECEDOR */
DECLARE  @V_CDFORNECED          VARCHAR(21);
DECLARE  @V_IDBAIXAAF           VARCHAR(1);

/*DECLARE VARIAVEL DO CURSOR C_NOTAPREVISTA */
DECLARE  @V_NRLANCTONF          VARCHAR(10);
DECLARE  @V_DTPROGENTAF         DATETIME;

/*DECLARE CURSOR C_CONTAPAGAR */
DECLARE  @V_CDEMPRESA           VARCHAR(2);
DECLARE  @V_DTMOVFLUXO          DATETIME;
DECLARE  @V_IDMOVFLUXO          VARCHAR(1);
DECLARE  @V_CDCLASSFINA         VARCHAR(6);
DECLARE  @V_VRORIGPAG           DOUBLE PRECISION;
DECLARE  @V_VRATUAPAG           DOUBLE PRECISION;

/*DECLARE CURSOR C_ORCAFINA */
DECLARE  @V_CDEMPRESAOF         VARCHAR(2);
DECLARE  @V_CDFILIALOF          VARCHAR(4);
DECLARE  @V_CDCLASSFINAOF       VARCHAR(6);
DECLARE  @V_DTORCAFINAOF        DATETIME;

BEGIN
   DECLARE C_FORNECEDOR CURSOR FOR
   SELECT
      CDFORNECED,
      IDBAIXAAF
   FROM
      AUTOFORNE
   WHERE
      CDFILDEST  = @P_CDFILDEST   AND
      CDFILLANC  = @P_CDFILLANC   AND
      NRAUTOFORN = @P_NRAUTOFORN

   OPEN C_FORNECEDOR;
   FETCH NEXT FROM C_FORNECEDOR INTO @V_CDFORNECED, @V_IDBAIXAAF;
   WHILE (@@FETCH_STATUS = 0) BEGIN
      SELECT
         @V_IDGERCONTPGT = MAX(IDGERCONTPGT)
      FROM
         FORNECEDOR
      WHERE
         CDFORNECED = @V_CDFORNECED;

      SELECT
         @V_IDCONSORCFIN = MAX(IDCONSORCFIN),
         @V_IDTPORCAFINA = MAX(IDTPORCAFINA)
      FROM
         PARAMGERAL;

      IF @V_IDGERCONTPGT = 'S' BEGIN
         DECLARE C_NOTAPREVISTA CURSOR FOR
         SELECT DISTINCT
            NRLANCTONF, DTPROGENTAF
         FROM
            ITEMAUTF
         WHERE
            CDFILLANC  = @P_CDFILLANC AND
            CDFILDEST  = @P_CDFILDEST AND
            NRAUTOFORN = @P_NRAUTOFORN

         OPEN C_NOTAPREVISTA;
         FETCH NEXT FROM C_NOTAPREVISTA INTO @V_NRLANCTONF, @V_DTPROGENTAF;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            IF @V_IDBAIXAAF IN ('3', '4', '5') BEGIN
            /*############################# TOTAL DOS ITEMS ##########################################*/
               SET @V_TOTITM_VRPROD_REST = 0;
               SELECT
                  @V_TOTITM_VRDESC = SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) * (ISNULL(ITEMAUTF.VRPERDESAF,0) / 100)),
                  @V_TOTITM_VRPROD = SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
                  @V_TOTITM_TOT = SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) - ((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) * ISNULL(ITEMAUTF.VRPERDESAF,0) / 100))
               FROM
                  ITEMAUTF
               WHERE
                  ITEMAUTF.CDFILDEST   = @P_CDFILDEST  AND
                  ITEMAUTF.CDFILLANC   = @P_CDFILLANC  AND
                  ITEMAUTF.NRAUTOFORN  = @P_NRAUTOFORN AND
                  ITEMAUTF.DTPROGENTAF = @V_DTPROGENTAF;

               /*############################### TOTAL DOS IMPOSTOS #####################################*/
               SET @V_TOTIMP_TOT_REST = 0;
               SELECT
                  @V_TOTIMP_TOT = SUM (IMPITMAF.VRADIMPAF )
               FROM
                  IMPITMAF,  ITEMAUTF
               WHERE
                  ITEMAUTF.CDFILDEST   = @P_CDFILDEST   AND
                  ITEMAUTF.CDFILLANC   = @P_CDFILLANC   AND
                  ITEMAUTF.NRAUTOFORN  = @P_NRAUTOFORN  AND
                  ITEMAUTF.DTPROGENTAF = @V_DTPROGENTAF AND
                  IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST  AND
                  IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC  AND
                  IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN AND
                  IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO  AND
                  IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA    AND
                  IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF;
            END
            ELSE BEGIN
               /*############################# TOTAL DOS ITEMS ##########################################*/
               SELECT
                  @V_TOTITM_VRDESC = SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) * (ISNULL(ITEMAUTF.VRPERDESAF,0) / 100)),
                  @V_TOTITM_VRPROD = SUM(ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF),
                  @V_TOTITM_VRPROD_REST = SUM((ITEMAUTF.QTPROGENTAF - (CASE ITEMAUTF.IDBAIXITMAF WHEN '3' THEN ITEMAUTF.QTPROGENTAF ELSE ISNULL(ITEMAUTF.QTEFETENTRAF,0) END)) * ITEMAUTF.VRPREUNIAF),
                  @V_TOTITM_TOT = SUM((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) - ((ITEMAUTF.QTPROGENTAF * ITEMAUTF.VRPREUNIAF) * ISNULL(ITEMAUTF.VRPERDESAF,0) / 100))
               FROM
                  ITEMAUTF
               WHERE
                  ITEMAUTF.CDFILDEST   = @P_CDFILDEST  AND
                  ITEMAUTF.CDFILLANC   = @P_CDFILLANC  AND
                  ITEMAUTF.NRAUTOFORN  = @P_NRAUTOFORN AND
                  ITEMAUTF.DTPROGENTAF = @V_DTPROGENTAF;

               /*############################### TOTAL DOS IMPOSTOS #####################################*/
               SELECT
                  @V_TOTIMP_TOT_REST = SUM (IMPITMAF.VRADIMPAF * (ITEMAUTF.QTPROGENTAF - (CASE ITEMAUTF.IDBAIXITMAF WHEN '3' THEN ITEMAUTF.QTPROGENTAF ELSE ISNULL(ITEMAUTF.QTEFETENTRAF,0) END))/ITEMAUTF.QTPROGENTAF),
                  @V_TOTIMP_TOT = SUM (IMPITMAF.VRADIMPAF )
               FROM
                  IMPITMAF,  ITEMAUTF
               WHERE
                  ITEMAUTF.CDFILDEST   = @P_CDFILDEST         AND
                  ITEMAUTF.CDFILLANC   = @P_CDFILLANC         AND
                  ITEMAUTF.NRAUTOFORN  = @P_NRAUTOFORN        AND
                  ITEMAUTF.DTPROGENTAF = @V_DTPROGENTAF       AND
                  IMPITMAF.CDFILDEST   = ITEMAUTF.CDFILDEST   AND
                  IMPITMAF.CDFILLANC   = ITEMAUTF.CDFILLANC   AND
                  IMPITMAF.NRAUTOFORN  = ITEMAUTF.NRAUTOFORN  AND
                  IMPITMAF.CDPRODUTO   = ITEMAUTF.CDPRODUTO   AND
                  IMPITMAF.CDMARCA     = ITEMAUTF.CDMARCA     AND
                  IMPITMAF.DTPROGENTAF = ITEMAUTF.DTPROGENTAF AND
                  ISNULL(ITEMAUTF.QTPROGENTAF, 0) > 0;
            END;

            /*########################## ENCARGOS A ACRESCER #########################################*/
            SELECT
               @V_ENCACRES_TOTACRES = SUM(ENCARGOAF.VRENCARGOAF)
            FROM
               ENCARGOAF, ENCARGO
            WHERE
               ENCARGOAF.CDFILDEST   = @P_CDFILDEST  AND
               ENCARGOAF.CDFILLANC   = @P_CDFILLANC  AND
               ENCARGOAF.NRAUTOFORN  = @P_NRAUTOFORN AND
               ENCARGOAF.DTENTRENCAF = @V_DTPROGENTAF AND
               ENCARGOAF.CDENCARGO   = ENCARGO.CDENCARGO AND
               ENCARGO.IDENCARGO     = 'A';

            /*########################## ENCARGOS A DESCONTAR ########################################*/
            SELECT
               @V_ENCDESC_TOTDESC = SUM(ENCARGOAF.VRENCARGOAF)
            FROM
               ENCARGOAF, ENCARGO
            WHERE
               ENCARGOAF.CDFILDEST   = @P_CDFILDEST  AND
               ENCARGOAF.CDFILLANC   = @P_CDFILLANC  AND
               ENCARGOAF.NRAUTOFORN  = @P_NRAUTOFORN AND
               ENCARGOAF.DTENTRENCAF = @V_DTPROGENTAF AND
               ENCARGOAF.CDENCARGO   = ENCARGO.CDENCARGO AND
               ENCARGO.IDENCARGO     = 'D';

            /*########################## IMPOSTOS A RETER ############################################*/
            SELECT
               @V_IMPRETER_TOTIMPRET = SUM(IMPITMAF.VRIMPITMAF)
            FROM
               IMPOSTO, IMPITMAF
            WHERE
               IMPITMAF.CDFILDEST   = @P_CDFILDEST AND
               IMPITMAF.CDFILLANC   = @P_CDFILLANC AND
               IMPITMAF.NRAUTOFORN  = @P_NRAUTOFORN AND
               IMPITMAF.DTPROGENTAF = @V_DTPROGENTAF AND
               IMPOSTO.CDIMPOSTO    = IMPITMAF.CDIMPOSTO  AND
               IMPOSTO.IDTRATIMPO   = 'R';

            /*########################### CALCULO DOS VALORES ########################################*/

            SET @V_VRTOTCTPAGAR = ROUND(@V_TOTITM_TOT
                                        + ISNULL(@V_TOTIMP_TOT,0)
                                        + ISNULL(@V_ENCACRES_TOTACRES,0)
                                        - ISNULL(@V_ENCDESC_TOTDESC,0)
                                        - ISNULL(@V_IMPRETER_TOTIMPRET, 0), 5);

            SET @V_VRTOTAL_REST = ROUND(@V_TOTITM_VRPROD_REST + ISNULL(@V_TOTIMP_TOT_REST,0), 5);

            IF @V_TOTITM_VRPROD = @V_TOTITM_VRPROD_REST BEGIN/* SE OS ITEMS ESTIVEREM EM ABERTO... */
               SET @V_VRTOTAL_REST = ROUND(@V_VRTOTAL_REST
                                           - ISNULL(@V_TOTITM_VRDESC,0)
                                           + ISNULL(@V_ENCACRES_TOTACRES,0)
                                           - ISNULL(@V_ENCDESC_TOTDESC,0)
                                           - ISNULL(@V_IMPRETER_TOTIMPRET, 0), 5);
            END;

            IF (@V_VRTOTAL_REST < 0) BEGIN
               SET @V_VRTOTAL_REST = 0;
            END;

            /*########################### MOVIMENTO DE FLUXO #########################################*/
            DECLARE C_CONTAPAGAR CURSOR FOR
            SELECT
               CDEMPRESA, DTMOVFLUXO, IDMOVFLUXO,
               CDCLASSFINA, VRORIGPAG, VRATUAPAG
            FROM
               CONTAPAGAR
            WHERE
               CDFILIAL   = @P_CDFILLANC AND
               NRLANCTONF = @V_NRLANCTONF

            OPEN C_CONTAPAGAR;
            FETCH NEXT FROM C_CONTAPAGAR INTO @V_CDEMPRESA  , @V_DTMOVFLUXO, @V_IDMOVFLUXO,
                                              @V_CDCLASSFINA, @V_VRORIGPAG , @V_VRATUAPAG;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SET @V_VRATUAPAGAUX = ROUND(@V_VRTOTAL_REST * @V_VRORIGPAG/ @V_VRTOTCTPAGAR,2);
               SET @V_VRATUAPAGAUX = @V_VRATUAPAGAUX - @V_VRATUAPAG;
               EXEC ATUALIZA_FLUXO_DE_CAIXA @V_CDEMPRESA, @P_CDFILDEST, @V_DTMOVFLUXO,
                                            @V_IDMOVFLUXO, @V_CDCLASSFINA, 0,
                                            @V_VRATUAPAGAUX;

               UPDATE MOVFLUXAF
               SET VRPREVAF = VRPREVAF + @V_VRATUAPAGAUX
               WHERE
                  CDFILDEST    = @P_CDFILDEST AND
                  CDFILLANC    = @P_CDFILLANC AND
                  NRAUTOFORN   = @P_NRAUTOFORN AND
                  CDCLASSFINAF = @V_CDCLASSFINA AND
                  DTENTMOVAF   = @V_DTPROGENTAF AND
                  DTPREVVENC   = @V_DTMOVFLUXO;

               /*######################## ORCAMENTO FINANCEIRO ##########################################*/
               IF (@V_IDCONSORCFIN = 'S') BEGIN
                  SET @V_CDFILIAL = NULL;

                  IF @V_IDTPORCAFINA = 'F' BEGIN
                     SET @V_CDFILIAL = @P_CDFILDEST;
                  END;

                  DECLARE C_ORCAFINA CURSOR FOR
                  SELECT
                     CDEMPRESA, CDFILIAL,
                     CDCLASSFINA,  DTORCAFINA
                  FROM
                     ORCAFINA
                  WHERE
                     (CDEMPRESA   = @V_CDEMPRESA) AND
                     (CDFILIAL    = ISNULL(@V_CDFILIAL, CDFILIAL)) AND
                     (CDCLASSFINA = @V_CDCLASSFINA) AND
                     (DTORCAFINA BETWEEN @V_DTMOVFLUXO - DAY(@V_DTMOVFLUXO) + 1 AND
                                          DATEADD(MM,1,@V_DTMOVFLUXO)-DAY(@V_DTMOVFLUXO));

                  OPEN C_ORCAFINA;
                  FETCH NEXT FROM C_ORCAFINA INTO @V_CDEMPRESAOF, @V_CDFILIALOF, @V_CDCLASSFINAOF, @V_DTORCAFINAOF;

                  WHILE (@@FETCH_STATUS = 0) BEGIN
                     UPDATE ORCAFINA
                     SET
                        VRREALORCA = VRREALORCA + @V_VRATUAPAGAUX
                     WHERE
                        CDCLASSFINA = @V_CDCLASSFINAOF AND
                        CDEMPRESA   = @V_CDEMPRESAOF   AND
                        DTORCAFINA  = @V_DTORCAFINAOF  AND
                        CDFILIAL    = @V_CDFILIALOF;

                     FETCH NEXT FROM C_ORCAFINA INTO @V_CDEMPRESAOF, @V_CDFILIALOF, @V_CDCLASSFINAOF, @V_DTORCAFINAOF;
                  END;
                  CLOSE C_ORCAFINA;
                  DEALLOCATE C_ORCAFINA;
               END;

               FETCH NEXT FROM C_CONTAPAGAR INTO @V_CDEMPRESA  , @V_DTMOVFLUXO, @V_IDMOVFLUXO,
                                                 @V_CDCLASSFINA, @V_VRORIGPAG , @V_VRATUAPAG;
            END;
            CLOSE C_CONTAPAGAR;
            DEALLOCATE C_CONTAPAGAR;

            /*############################ AJUSTE NA CONTA A PAGAR ###################################*/
            UPDATE CONTAPAGAR
            SET VRATUAPAG = ROUND(@V_VRTOTAL_REST * VRORIGPAG / @V_VRTOTCTPAGAR,2)
            WHERE
               CDFILIAL   = @P_CDFILLANC AND
               NRLANCTONF = @V_NRLANCTONF;

            /*############################ CANCELA A NOTA FISCAL (SE NECESSARIO) #####################*/
            /* SE CONTAPAGAR.VRATUAPAG <= 0 ENTAO CANCELA A NF*/
            SELECT @V_VRATUAPAGAUX = SUM(CONTAPAGAR.VRATUAPAG)
            FROM CONTAPAGAR
            WHERE CONTAPAGAR.CDFILIAL   = @P_CDFILLANC AND
                  CONTAPAGAR.NRLANCTONF = @V_NRLANCTONF;

            SET @V_IDSTATUSAUX = 'V';

            IF @V_VRATUAPAGAUX <= 0 BEGIN
               SET @V_IDSTATUSAUX = 'C';
            END;

            UPDATE NOTAFISCAL
            SET IDSTATUS = @V_IDSTATUSAUX
            WHERE
               CDFILIAL   = @P_CDFILLANC AND
               NRLANCTONF = @V_NRLANCTONF;

            FETCH NEXT FROM C_NOTAPREVISTA INTO @V_NRLANCTONF, @V_DTPROGENTAF;
         END;
         CLOSE C_NOTAPREVISTA;
         DEALLOCATE C_NOTAPREVISTA;
      END;
      FETCH NEXT FROM C_FORNECEDOR INTO @V_CDFORNECED, @V_IDBAIXAAF;
   END;
   CLOSE C_FORNECEDOR;
   DEALLOCATE C_FORNECEDOR;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'AJUSTE_CONTPREVISTA','4.11.020';
GO

